case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
    fi
    . ./config.sh

    ;;
esac

case "$subdir" in
'')
    case "$0" in
    */*) cd `expr X$0 : 'X\(.*\)/'` ;;
    esac	    

    vpathdef="#VPATH	= "
    XXsrc="."
    XXsrcroot="../../"
    ;;
*)
    vpathdef="VPATH	=	$source_dir/$subdir"
    XXsrc="$source_dir/$subdir"
    XXsrcroot="$source_dir"
    ;;
esac

echo "Extracting shared_libs/tls/Makefile (with variable substitutions)"
$cat >Makefile <<!GROK!THIS!
#!$make
# $Id: Makefile.SH,v 1.16.22.6 2005/09/29 17:44:41 hurtta Exp $
#
#
#  Makefile for the ELM (ME+) mail program.
#
#  Author: Kari Hurtta <hurtta+elm@posti.FMI.FI> (was hurtta+elm@ozone.FMI.FI)
#
#
INSTLIB		= \$(ELM_ROOT)//$shlib/libelmme-tls.so$d_shared_rev
AR		=	$ar
CC		=	$cc
CCFLAGS		=	$ccflags $picflag $xencf
CP		=	$cp
RM              =       $rm -f
MV              =       $mv
OPTIMIZE	=	$optimize
RANLIB		=	$ranlib
TOUCH           =       $touch
CHMOD           =       $chmod
REG             =       ../../bin/elmregister -M tls
$vpathdef
SRC		=	$XXsrc
SRCROOT		=	$XXsrcroot
!GROK!THIS!

A=
if $test "$soname_include_path" = y ; then
	A="$shlib/"
fi

cat >>Makefile <<SUBSTITUTE
SONAME          = ${soname_opt}${A}libelmme-tls.so$d_shared_rev
SUBSTITUTE

if $test "$tls_lib_dir" != ""; then
    $cat >>Makefile <<EOS
LIBDIRLIST      =  -L$tls_lib_dir $rpath_opt$tls_lib_dir
EOS
else
    cat >>Makefile <<'EOX'
LIBDIRLIST      =
EOX
fi

if $test "$tls_include_dir" != "" ; then
    $cat >>Makefile <<EOS
INCDIRLIST      = -I$tls_include_dir
EOS
else
    $cat >>Makefile <<'EOX'
INCDIRLIST      =
EOX

fi
$cat >>Makefile <<'!NO!SUBS!'
CFLAGS		=	-I$(IHDR) -I$(INCLDIR) -I$(IHDR2) \
 -I$(INCLDIR2) $(INCDIRLIST) $(CCFLAGS) $(OPTIMIZE)
INCLDIR		=	$(SRCROOT)/shared_libs/include
INCLDIR2	=	$(SRCROOT)/hdrs
IHDR		=	../include
IHDR2		=	../../hdrs
OBJS            =       pop.o tls.o imap.o

all:	Makefile libtls.a ../../shlib/libelmme-tls.so
install_s: all $(INSTLIB)

uninstall_s:
	$(REG) rm $(INSTLIB)

clean: 
	rm -f $(OBJS) ../../shlib/libelmme-tls.so libtls.a

.PRECIOUS: $(IHDR)/elmshared.h o$(IHDR2)/elm_defs.h $(IHDR2)/defs_major.h

$(IHDR)/elmshared.h: $(IHDR2)/elm_defs.h $(INCLDIR2)/patchlevel.h \
 $(INCLDIR)/shared.h 
	$(CHMOD) u+w $@
	$(TOUCH) $@

$(IHDR2)/elm_defs.h: $(IHDR2)/defs_major.h $(INCLDIR2)/elm_nl_types.h \
 $(INCLDIR2)/hdrs/elmlib.h 
			$(CHMOD) u+w $@
			$(TOUCH) $@

$(IHDR2)/defs_major.h: ../../config.h $(IHDR2)/sysdefs.h 
			$(CHMOD) u+w $@
			$(TOUCH) $@

Makefile: Makefile.SH ../../config.sh config.res
	@echo "You must run 'sh Configure -S' or 'sh Configure'"
	exit 1

../../config.sh config.res:
	@echo "You must run 'sh Configure'"
	exit 1

lint:		

tags:

clean:		

elmtls.h: $(INCLDIR)/elmshared.h $(INCLDIR2)/ss_imp.h $(INCLDIR2)/mbx_imp.h 
	cmp $(SRC)/$@ $@ || $(CP) $(SRC)/$@ $@
	$(CHMOD) u+w $@
	$(TOUCH) $@

pop.o: elmtls.h
tls.o: elmtls.h $(INCLDIR2)/save_opts.h $(INCLDIR2)/rc_imp.h
imap.o: elmtls.h


libtls.a: $(OBJS)
	$(AR) r $@ $?
	$(RANLIB) $@

../../shlib/libelmme-tls.so: $(OBJS)
	$(CC) $(CCFLAGS) $(LIBDIRLIST) $(SONAME) -o $@ $(OBJS) -lssl -lcrypto 

$(INSTLIB): ../../shlib/libelmme-tls.so
	$(REG) copy -m 444 $? $@

!NO!SUBS!

for i in $headers 
do
	cat >>Makefile <<!SUBS!
copy_$i:    \$(INCLDIR2)/$i
		cmp \$? \$(IHDR2)/$i || \$(CP) \$? \$(IHDR2)/$i

!SUBS!
done
